<?php
/**
 * Sobak CMS 0.2
 * functions file
 * Copyright by Sobak (http://sobak.pl/) 2010-11
**/

/**********************************************************
 * Database functions
 * db_connect, db_query, secure
**********************************************************/
function db_connect () {
	global $conn;

	include ('config.php');
	$conn = @mysql_connect ($cfg['db_server'], $cfg['db_user'], $cfg['db_pass']) or die ('Nieudane połączenie z DB');
	@mysql_select_db ($cfg['db_name'], $conn) or die ('Nieudany wybór DB');
}

function db_query ($query) {
    global $conn;
    $q = mysql_query ($query, $conn) or die ('<b>Błąd:</b> '.mysql_error());
    return $q;
}

function secure ($txt, $sql, $html) {
    $txt = trim ($txt);
    if ($sql != false) {
        mysql_real_escape_string ($txt);
    }

    if ($html != false) {
        htmlspecialchars ($txt);
 }
}


/**********************************************************
 * Core functions
 * getSetting
**********************************************************/
function getSetting ($set) {
	global $conn;
	$query = db_query ("SELECT value FROM `cms_settings` WHERE `setting` = '$set' LIMIT 1", true);
	$setting = mysql_fetch_array ($query);
	return $setting[0];
}


/**********************************************************
 * Messages functions
 * printMessage, printError (Unused)
**********************************************************/
function printMessage ($msg, $title = 'Komunikat') {
 echo "<p class=\"message\">\n";
  echo "<b>$title</b><br />\n";
  echo $msg."\n";
 echo "</p>\n";
}

function printError ($msg, $title = 'Błąd') {
 echo "<p class=\"error\">\n";
  echo "<b>$title</b><br />\n";
  echo $msg."\n";
 echo "</p>\n";
}


/**********************************************************
 * User system funcions
 * usIsLogged, usGet, usGetByID, usPassWithSalt
**********************************************************/
function usGet ($login, $pass) {
 global $user;
 $user = mysql_fetch_array(db_query("SELECT * FROM `cms_users` WHERE `login`='$login' AND `pass`='$pass' LIMIT 1"));
 return $user;
}

function usGetByID ($id) {
 global $user;
 $user = mysql_fetch_array(mysql_query("SELECT * FROM `cms_users` WHERE `id`='$id' LIMIT 1")) or die ('<b>Błąd</b>: '.mysql_error());
}

function usIsLogged () {
 $login = $_SESSION['login'];
 $pass = $_SESSION['pass'];

 if ((empty($login)) OR (empty($pass))) {
  return false;
 } else {
  return true;
 }
}

function usPassWithSalt ($pass) {
 $pass = '4fs5vst4hns324kslrg3'.md5($pass).'dsafahn59843rft';
 return $pass;
}


/**********************************************************
 * Other functions
 * randomString
**********************************************************/
function randomString ($limit) {
  return substr(md5(date("d.m.Y.H.i.s").rand(1,1000000)) , 0 , $limit);
}

function last_articles () {
    db_query ("");
}

/**
 * function menuGenerator
 * required used usGet(); and db_connect (); before that!
**/
function menuGenerator () {
global $user;

if ($_COOKIE['mobile'] == 1) {
    // Menu for mobile version
    $m = '<div class="menu">'."\n";
  $m .= "<b>Menu</b>:";
  
  $result = mysql_query ("SELECT `url`, `name` FROM `cms_menu` ORDER BY `order`");
  
  while ($row = mysql_fetch_array($result)) {
   $m .= '<a href="'.$row['url'].'">'.$row['name'].'</a> | ';
  }
  
  /**
   * Menu użytkowników
   * Profil, wylogowanie itd... (dostępne tylko dla zalogowanych użytkowników)
   * Odnośniki do logowania i rejestracji dla użytkowników niezalogowanych
  **/	
  $m .= "\n<br /><b>Użytkownik:</b>";
   if (usIsLogged () != true) {
	$m .= '<a href="index.php?id=user&amp;mode=register">Rejestracja</a> | ';
	$m .= '<a href="index.php?id=user&amp;mode=login">Logowanie</a>';
   }
	
  else {
   usGet ($_SESSION['login'], $_SESSION['pass']);
   //Link do panelu administracyjnego
   if ($user['level'] == 1) {
	$m .= '<a href="admin/index.php"><b>Panel Administracyjny</b></a> | ';
   }
  $m .= '<a href="index.php?id=user&amp;mode=profile&amp;userID='.$user['id'].'">Profil</a> | ';
  $m .= '<a href="index.php?id=user&amp;mode=logout">Wyloguj ('.$user['login'].')</a>';
  }
$m .= "</div>\n";

}

else {
    // Menu for normal version
$m = '<div class="menu">'."\n";
 $m .= "<dl>\n";
  $m .= "<dt>Menu</dt>\n";
  
  $result = mysql_query ("SELECT `url`, `name` FROM `cms_menu` ORDER BY `order`");
  
  while ($row = mysql_fetch_array($result)) {
   $m .= '<dd><img src="themes/'.getSetting('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="'.$row['url'].'">'.$row['name'].'</a></dd>'."\n";
  }
  
  /**
   * Menu użytkowników
   * Profil, wylogowanie itd... (dostępne tylko dla zalogowanych użytkowników)
   * Odnośniki do logowania i rejestracji dla użytkowników niezalogowanych
  **/	
  $m .= "<dt>Użytkownik</dt>\n";
   if (usIsLogged () != true) {
	$m .= '<dd><img src="themes/'.getSetting ('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="index.php?id=user&amp;mode=register">Rejestracja</a></dd>'."\n";
	$m .= '<dd><img src="themes/'.getSetting ('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="index.php?id=user&amp;mode=login">Logowanie</a></dd>'."\n";
   }
	
  else {
   usGet ($_SESSION['login'], $_SESSION['pass']);
   //Link do panelu administracyjnego
   if ($user['level'] == 1) {
	$m .= '<dd><img src="themes/'.getSetting ('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="admin/index.php"><b>Panel Administracyjny</b></a></dd>'."\n";
   }
  $m .= '<dd><img src="themes/'.getSetting ('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="index.php?id=user&amp;mode=profile&amp;userID='.$user['id'].'">Profil</a></dd>';
  $m .= '<dd><img src="themes/'.getSetting ('theme').'/img/menu.jpg" alt="" />&nbsp;<a href="index.php?id=user&amp;mode=logout">Wyloguj ('.$user['login'].')</a></dd>';
  }
 $m .= "</dl>\n";
$m .= "</div>\n";
}

echo $m;
}

/**********************************************************
 * Mobile functions
 * is_mobile_version, show_mobile_link
**********************************************************/

// Check whether mobile version is active
function is_mobile_version () {
    if ($_COOKIE['mobile'] == 1) {
        return true;
    }

    else {
        return false;
    }
}

// Show link to mobile version (enbable or disable)
function show_mobile_link () {
    if (is_mobile_version ()) {
        echo '<a class="mobile-link" href="index.php?id=mobile&amp;off=true">Wersja pełna</a>';
    }

    else {
        echo '<a class="mobile-link" href="index.php?id=mobile">Wersja mobilna</a>';
    }
}

/**********************************************************
 * Lang functions
 * get_lang
**********************************************************/

function get_lang () {
    if (usIsLogged ($login, $pass)) {
        $user = usGet($login = $_SESSION['login'], $pass = $_SESSION['pass']);
        $user_lang = $user['lang'];
    }

    else {
        $user_lang = getSetting('default_lang');
    }

    return $user_lang;
}

function include_lang ($file) {
    global $lang;
    
    $set_lang = get_lang();
    include "languages/$set_lang/$file.php";
}

/**********************************************************
 * Content functions
 * comments, show_tags
**********************************************************/
function comments () {
 global $user, $pass, $content, $result, $lang;
 include_lang('comments');

 $id = $content['id'];

 //Show comments
 $result = db_query ("SELECT author, content, date FROM cms_comments WHERE page_id='$id' AND moderated=1") or die ('<b>Błąd</b>: '.mysql_error());

 echo '<h2>'.$lang['title_comments'].'</h2>';

 if (mysql_num_rows($result) == 0) {
  echo $lang['no_comments'];
 }

 while ($row = mysql_fetch_array ($result)) {
  echo '<b>'.$row['author'].':</b> '.$row['content']."<br />\n";
 }

 //Comments form
if (usIsLogged ($user, $pass)) {
 if ($content['allow_comments'] == 1) {
  echo '<h2>'.$lang['title_add_comment'].'</h2>';
  echo '<form action="index.php?id=comment&pageID='.$id.'" method="post">'."\n";
  echo "\t".$lang['nick'].$user['login']."<br />\n";
  echo "\t".$lang['comment'].'<br /><textarea name="commentText">'.$lang['type_your_comment'].'</textarea>'."\n";
  echo "\t".'<br /><input type="submit" value="'.$lang['send_comment'].'" />'."\n";
  echo '</form>'."\n";
 }

 else {
  echo $lang['comments_disabled'];
 }
}

else {
 echo $lang['comments_only_for_logged_users'];
 if ($content['allow_comments'] == 0) {
  echo $lang['comments_disabled'];
 }
}

//function close
}

function show_tags ($id) {
    $query = mysql_query("SELECT tags FROM cms_articles WHERE id='$id'") or die (mysql_error());
    echo '<b>Tagi</b> ';
    $row = mysql_fetch_array($query);
        $tag = explode (',', $row['tags']);

        for ($i = 0;  $i <= count($tag)-1; $i++) {
         echo '<a href="index.php?id=tag&amp;tag='.$tag[$i].'">'.$tag[$i].'</a>';
         if ($i != count($tag)-1) {
             echo ', ';
         }
        }
}

?>