<?php
/**
 * @package Iron CMS
 * @author Sobak
 */
class logger {
    private $logFile = 'logs.log';
    private $logsDir = 'logs/'; // With ending slash!
    private $dateFormat = 'd.m.Y H:i';

    private function isLogged () {
         $login = $_SESSION['login'];
         $pass = $_SESSION['pass'];

         if ((empty($login)) OR (empty($pass))) {
          return false;
         } else {
          return true;
         }
    }

    /**
     *
     * error types ($type var)
     * 1 - critical error
     * 2 - warning
     * 3 - notice
     */

    public function add_event ($type, $file, $line, $extra_information = '') {
        $date = date (self::$dateFormat);
        $ip   = $_SERVER['REMOTE_ADDR'];

        if (self::isLogged()) {
            $login = $_SESSION['login'];
        } else {
            $login = 0;
        }

        $log [] = array ('type' => $type, 'file' => $file, 'line' => $line, 'date' => $date, 'ip' => $ip, 'login' => $login, 'extra' => $extra_information);

        file_put_contents ('../'.self::$logsDir.self::$logFile, $log[count($log)-1]."\n", FILE_APPEND | LOCK_EX);
    }
}

?>