<?php
require('libs/Smarty.class.php');

$tpl = new Smarty;

$tpl->debugging = false;
$tpl->caching = true;

//Header variables
$tpl->assign('site_title', getSetting('site_title'));
$tpl->assign('page_title', $content['title']);
$tpl->assign('additional_headers', $content['additional_headers']);

//Set description meta-tag
if (empty($content['description'])) {
 $tpl->assign('description', getSetting('description'));
} else {
 $tpl->assign('desription', $content['description']);
}

//Set keywords meta-tag
if (empty($content['keywords'])) {
 $tpl->assign('keywords', getSetting('keywords'));
} else {
 $tpl->assign('keywords', $content['keywords']);
}

$tpl->assign('version', getSetting('version'));

//Universal vars
$tpl->assign('site_url', getSetting('site_url'));


//Menu
menuGenerator ();
$tpl->assign('menu', $m);

//Set content
function content () {
if ($isInWebs == true) {
 include ('webs/'.$id.'.php'); 
}

else {
 return $content['content'];

 //comments ();
}
}

function userbar () {
   if (isset($login) and isset ($pass)) {
    echo 'Witaj '.$user['login'].'. Co u Ciebie? Może chcesz się <a href="index.php?id=user&amp;mode=logout">wylogować</a> lub obejrzeć <a href="index.php?id=user&amp;mode=profile&amp;id='.$user['id'].'">swój profil</a>?';
   }
   else {
    echo 'Nie jesteś zalogowany. <a href="index.php?id=user&amp;mode=register">Zarejestruj się</a> lub <a href="index.php?id=user&amp;mode=login">Zaloguj</a> jeśli już masz konto.';
   }
}

//Set userbar
if (isset($login) and isset ($pass)) {
 $tpl->assign('userbar', 'Witaj '.$user['login'].'. Co u Ciebie? Może chcesz się <a href="index.php?id=user&amp;mode=logout">wylogować</a> lub obejrzeć <a href="index.php?id=user&amp;mode=profile&amp;id='.$user['id'].'">swój profil</a>?');
} else {
 $tpl->assign('userbar', 'Nie jesteś zalogowany. <a href="index.php?id=user&amp;mode=register">Zarejestruj się</a> lub <a href="index.php?id=user&amp;mode=login">Zaloguj</a> jeśli już masz konto.');
}

$tpl->assign('theme', getSetting('theme'));

if ($isInWebs) {
 //$f = fopen ('webs/'.$id.'.php', 'a+');
 //$code = fread ($f, filesize('webs/'.$id.'.php'));
 $code = file_get_contents ('webs/'.$id.'.php');
 echo $code;
 //$tpl->assign('content', $code);
} else {
 $tpl->assign('content', $content['content']);
}

$tpl->display('index.tpl');

?>