-- phpMyAdmin SQL Dump
-- version 3.2.4
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Czas wygenerowania: 08 Lut 2011, 15:57
-- Wersja serwera: 5.1.41
-- Wersja PHP: 5.3.1

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Baza danych: `cms`
--

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_activation`
--

CREATE TABLE IF NOT EXISTS `cms_activation` (
  `hash` varchar(15) COLLATE utf8_bin NOT NULL,
  `id` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

--
-- Zrzut danych tabeli `cms_activation`
--


-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_articles`
--

CREATE TABLE IF NOT EXISTS `cms_articles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` varchar(20) COLLATE utf8_bin NOT NULL,
  `author` varchar(35) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `content` text CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `title` varchar(150) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `rss_random` varchar(10) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=7 ;

--
-- Zrzut danych tabeli `cms_articles`
--

INSERT INTO `cms_articles` (`id`, `date`, `author`, `content`, `title`, `rss_random`) VALUES
(5, '0000-00-00 00:00:00', 'Admin', '<p>BÄ™dzie dziaA‚aÄ‡ :)</p>', 'Test daty :)', 'b6872e5b9b'),
(6, '1295033015', 'Admin', '<p>Lorem ipsum...</p>', 'I jeszcze raz data', 'c9762c5a28');

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_comments`
--

CREATE TABLE IF NOT EXISTS `cms_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `author` varchar(35) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `date` varchar(30) COLLATE utf8_bin NOT NULL,
  `content` text CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `page_id` varchar(35) COLLATE utf8_bin NOT NULL,
  `moderated` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=6 ;

--
-- Zrzut danych tabeli `cms_comments`
--

INSERT INTO `cms_comments` (`id`, `author`, `date`, `content`, `page_id`, `moderated`) VALUES
(1, 'Admin', '15.01.2011 20:45', '<h1>Zmoderowano</h1>', 'main_page', 1),
(4, 'NormalUser', '19.01.2011 18:45', '<p>A to zaakceptuj jeA›li moA1esz</p>', 'main_page', 1);

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_content`
--

CREATE TABLE IF NOT EXISTS `cms_content` (
  `additional_headers` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `allow_comments` tinyint(1) NOT NULL,
  `id` varchar(40) NOT NULL,
  `content` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `description` varchar(200) NOT NULL,
  `keywords` varchar(200) NOT NULL,
  `title` varchar(100) NOT NULL,
  `in_trash` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `cms_content`
--

INSERT INTO `cms_content` (`additional_headers`, `allow_comments`, `id`, `content`, `description`, `keywords`, `title`, `in_trash`) VALUES
('', 1, 'main_page', '<p>Lorem ipsum dolor si <strong>test</strong></p>', 'Strona Glowna', 'strona, glowna', 'Strona GA‚A3wna', 0),
('<!---->', 0, 'test', 'Czas troszkÄ™ potestowaÄ‡ dodawanie <b>nowych</b> stron w moim CMSie :)', 'TestA3wka', 'test, 1', 'Strona testowa', 0),
('', 0, 'error_404', 'Przykro nam, ale strona o podanym adresie nie istnieje w naszym serwisie :(', 'Przykro nam, ale strona o podanym adresie nie istnieje :(', 'error, 404, http', 'BA‚Ä…d 404 - Strona nie istnieje', 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_download`
--

CREATE TABLE IF NOT EXISTS `cms_download` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(40) NOT NULL,
  `description` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Zrzut danych tabeli `cms_download`
--


-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_links`
--

CREATE TABLE IF NOT EXISTS `cms_links` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(50) NOT NULL,
  `name` varchar(50) NOT NULL,
  `description` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Zrzut danych tabeli `cms_links`
--


-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_menu`
--

CREATE TABLE IF NOT EXISTS `cms_menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order` int(11) NOT NULL,
  `name` varchar(100) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,
  `url` varchar(200) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin AUTO_INCREMENT=5 ;

--
-- Zrzut danych tabeli `cms_menu`
--

INSERT INTO `cms_menu` (`id`, `order`, `name`, `url`) VALUES
(1, 1, 'Strona gA‚A3wna', 'index.php'),
(2, 2, 'Strona testowa', 'index.php?id=test'),
(3, 3, 'ArtykuA‚y', 'index.php?id=articles');

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_settings`
--

CREATE TABLE IF NOT EXISTS `cms_settings` (
  `setting` varchar(40) NOT NULL,
  `value` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `cms_settings`
--

INSERT INTO `cms_settings` (`setting`, `value`) VALUES
('site_title', 'PrzykA‚adowa strona oparta na Sobak CMS'),
('version', '0.3dev'),
('analytics_enable', '0'),
('analytics_code', 'UA-20037187-1'),
('theme', 'default'),
('wysiwyg_enable', '1'),
('admin_email', 'tu_podaj@swoj.mail'),
('default_keywords', 'sobak, CMS, domyA›lne'),
('default_description', 'Oto przykA‚ad domyA›lnego opisu :)'),
('comments_wysiwyg', '1'),
('short_news_lenght', '100'),
('home_id', 'test2');

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_static`
--

CREATE TABLE IF NOT EXISTS `cms_static` (
  `additional_headers` text CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `allow_comments` tinyint(1) NOT NULL,
  `id` varchar(40) NOT NULL,
  `description` varchar(200) NOT NULL,
  `keywords` varchar(200) NOT NULL,
  `title` varchar(100) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `cms_static`
--

INSERT INTO `cms_static` (`additional_headers`, `allow_comments`, `id`, `description`, `keywords`, `title`) VALUES
('', 0, 'user', 'System UA1ytkownikA3w', 'users, system, uA1ytkownicy, rejestracja, logowanie, profil', 'System UA1ytkownikA3w'),
('', 0, 'articles', 'Tutaj moA1esz przeczytaÄ‡ moje artykuA‚y :)', 'artykuA‚y, wpisy, posty, blog', 'ArtykuA‚y'),
('', 0, 'comment', '', '', 'Nowy komentarz');

-- --------------------------------------------------------

--
-- Struktura tabeli dla  `cms_users`
--

CREATE TABLE IF NOT EXISTS `cms_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(32) NOT NULL,
  `pass` varchar(100) NOT NULL,
  `email` varchar(40) NOT NULL,
  `ip` varchar(20) NOT NULL,
  `level` tinyint(1) NOT NULL DEFAULT '0',
  `active` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8 ;

--
-- Zrzut danych tabeli `cms_users`
--

INSERT INTO `cms_users` (`id`, `login`, `pass`, `email`, `ip`, `level`, `active`) VALUES
(1, 'Admin', '4fs5vst4hns324kslrg30192023a7bbd73250516f069df18b500dsafahn59843rft', 'email@admin.com', '127.0.0.1', 1, 1),
(2, 'NormalUser', '4fs5vst4hns324kslrg362cc2d8b4bf2d8728120d052163a77dfdsafahn59843rft', 'test@mail.pl', '::1', 0, 1);