<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="pl" lang="pl">
<head>
  <base href="<?php echo $config['site_url']; ?>" />
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title><?php echo getSetting('site_title').' :: '.$content['title']; ?></title>

  <link rel="stylesheet" href="themes/<?php echo getSetting ('theme'); ?>/style.css" type="text/css" />
  <link rel="shortcut icon" href="themes/<?php echo getSetting('theme'); ?>/img/favicon.ico" />

  <meta name="keywords" content="<?php if (empty($content['keywords'])) {$content['keywords'] = getSetting('default_keywords'); echo $content['keywords'];} else {echo $content['keywords'];} ?>" />
  <meta name="description" content="<?php if (empty($content['description'])) {echo getSetting('default_description');} else {echo $content['description'];} ?>" />
  <meta name="generator" content="Sobak CMS <?php echo getSetting ('version'); ?>" />
  <?php
   echo $content['additional_headers'];
   if (getSetting ('analytics_enable') == '1') {
  ?>
  <script type="text/javascript">

    var _gaq = _gaq || [];
    _gaq.push(['_setAccount', '<?php echo getSetting ('analytics_code') ?>']);
    _gaq.push(['_trackPageview']);

    (function() {
      var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
      ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
      var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
    })();

  </script>




 <?php }


  if (getSetting('wysiwyg_enable') == 1 and $content['allow_comments'] == 1) {
   echo '<script type="text/javascript" src="modules/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>';
   echo '
   <script type="text/javascript">
   tinyMCE.init({
          mode : "textareas",
          theme : "simple",
		  theme_simple_toolbar_location : "top",
		  theme_simple_toolbar_align : "left",
          theme_advanced_statusbar_location : "bottom",
          theme_advanced_resizing : true
  });
  </script>';
  }
  ?>
</head>
<body>

<div class="background">
 <div id="logo"><h1><?php echo getSetting ('site_title'); ?></h1></div>
  <div id="container">
  <?php menuGenerator (); ?>

   <div class="content">
    <div class="text">

<p class="userbar">
 <?php
   if (isset($login) and isset ($pass)) {
    echo 'Witaj '.$user['login'].'. Co u Ciebie? Może chcesz się <a href="index.php?id=user&amp;mode=logout">wylogować</a> lub obejrzeć <a href="index.php?id=user&amp;mode=profile&amp;userID='.$user['id'].'">swój profil</a>?';
   }
   else {
    echo 'Nie jesteś zalogowany. <a href="index.php?id=user&amp;mode=register">Zarejestruj się</a> lub <a href="index.php?id=user&amp;mode=login">Zaloguj</a> jeśli już masz konto.';
   }
 ?>
</p>